/*
* rtekin, July 2020
*/
#define _GNU_SOURCE //sched_setaffinity(...)
#include <stdlib.h>
#include <unistd.h>
#include <sched.h>
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <string.h>
#include "hippo.h"
#include "hippo_app_functions.h"

#define MY_STACK_SIZE 32768
/*
* Lock physical memory in order to avoid virtual memory reallocation latency.
* Useful for real time process.
*
* Code and more explication in
* Christophe Blaess, "Solutions temps réel sous Linux", Chapitre 6.
*/
void lock_memory() {
  unsigned char t[MY_STACK_SIZE];
  memset(t, 0, MY_STACK_SIZE);
  if(mlockall(MCL_CURRENT | MCL_FUTURE) != 0){
    perror("mlocall");
    exit(EXIT_FAILURE);
  }
}

int main(int argc, char** argv) {
  // struct sched_param param;
  //
  // param.sched_priority = sched_get_priority_max(SCHED_FIFO);
  // if(sched_setscheduler(0, SCHED_FIFO, & param) != 0){
  //   perror("sched_setscheduler");
  //   exit(EXIT_FAILURE);
  // }
  //
  // lock_memory();
  engine_run(); // run hippo engine
  return (EXIT_SUCCESS);
}
